// Para ejecutar el programa se necesita primero arrancar MPI:
// lamboot -v nodos
// Y despus lanzar los procesos (21) que se quedan esperando:
// mpirun -w -c 21 /home/al-99-00/dchaparr/cuatrimestre2/arqui/FIND-FINAL/pseudofind 
// y despus para lanzar bsquedas se usa ufind, que se le pasan los mismos argumentos que al find

// El reparto de los directorios se hace por niveles. En general hay tres procesos para cada nivel, excepto con los
// primeros 3 procesos. El proceso 1 tiene el primer nivel. Los procesos 2 y 3 tienen el segundo nivel. Y a partir de
// ah, cada nivel corresponde a tres procesos.






#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>  /* librera para readdir */
#include <dirent.h>     /* librera para readdir */
#include <sys/stat.h>   /* librera para stat    */
#include <unistd.h>     /* librera para stat    */
#include <string.h>
#include <assert.h>
#include <mpi.h>
#define BUFSIZE		250	
#define NUMCARAC        1000000
typedef char t_lista[NUMCARAC];

int    cambio[41];

struct reg {
  char direc[200];
  char nombre[50];
  char tipo;
};

// Cada proceso guarda en esta tabla la cach que tiene que almacenar
struct reg tabla[100000];
int        indice;
int	   rank;

char dir_cache[]="/usr/lib/";
int proc_nivel=3;

// Cada proceso guarda en esta lista los resultados que tiene que devolver al proceso 0
t_lista lista;
char			buf[BUFSIZE];
int			bufint[1], bufint2[1];
int 			size;
int                     nivelmax;

struct pred {
	struct max {
		int existe;
		int valor;
	} maxdepth;
	struct min {
		int existe;
		int valor;
	} mindepth;
	struct nam {
		int existe;
		char valor[200];
	} name;
	struct typ {
		int existe;
		char valor;
	} typo; 
} predicados;

#define MAXCAMINO 200
char camino[MAXCAMINO];




// Se extraen los argumentos de la lnea de comandos
void extraer_argumentos (char *args){

  char *aux;
  char *argu[9];
  int ind,i ;


        ind=0;
        aux= strchr (args,'\n');
	*aux='\0'; 

	// Separar la lnea de argumentos
        do {
            argu[ind++]=args;
        	
	    args=strchr (args, ' ');
	    if (args)
	       *args++='\0';
	} while (args);
   

	// Doy valores por defecto al registro que guarda los argumentos
	strcpy (camino, "./");
	predicados.maxdepth.existe=0;
	predicados.maxdepth.valor=-1;
  
	predicados.mindepth.existe=0;
	predicados.mindepth.valor=-1;
	
	predicados.name.existe=0;
	strcpy (predicados.name.valor, "");
	
	predicados.typo.existe=0;
	predicados.typo.valor=' ';
	
	strcpy (camino,argu[0]);

	// Voy comprobando si existen los argumentos y guardo su valor
	for (i=1;i<ind;i++) {
	  
		if (!strcmp (argu[i],"-name")) {
			predicados.name.existe=1;
			strcpy (predicados.name.valor,argu[i+1]);
		}
		if (!strcmp (argu[i],"-type")) {
			predicados.typo.existe=1;
			predicados.typo.valor=*argu[i+1];
		}
		if (!strcmp (argu[i],"-mindepth")) {
			predicados.mindepth.existe=1;
			predicados.mindepth.valor= atoi (argu[i+1]);
		}
		if (!strcmp (argu[i],"-maxdepth")) {
			predicados.maxdepth.existe=1;
			predicados.maxdepth.valor=atoi (argu[i+1]);
		}
	}
  
	  printf ("Camino: %s \n",camino);
	  printf ("Maxdepth: %d \n", predicados.maxdepth.valor);
	  printf ("Mindepth: %d\n", predicados.mindepth.valor);
	  printf ("Name : %s \n", predicados.name.valor);
	  printf ("Typo : %c \n", predicados.typo.valor);
}

void recorrer_directorio (char *nombre_directorio, int nivel)
{
	struct dirent *entrada;
	DIR *puntdir;
	char auxcad[200], auxcad2[200];
	int mando;
	
	struct stat buffer;
	MPI_Request req;
	
	// La variable cambio la voy utilizando para cambiar de proceso al que cambiar dentro 
	// del mismo nivel. En cada nivel hay tres procesos, y con esta variable cada vez
	// mando a uno de ellos. Lo hago para que no se sature un proceso, y los otros dos no
	// tengan nada que hacer.
	cambio[nivel]=1;
	
	puntdir = opendir (nombre_directorio);  //abro directorio
 
	while ((puntdir!=NULL) && ((entrada = readdir (puntdir)) != NULL)) { 
		
	        strcpy (auxcad, nombre_directorio);
		strcat (auxcad, entrada->d_name);
		
		lstat (auxcad, &buffer);


		// Si es un directorio, y es distinto de "." y de ".."
		if (S_ISDIR(buffer.st_mode) && (strcmp(entrada->d_name, ".")!=0) && (strcmp(entrada->d_name, "..")!=0)) {
			strcat (auxcad, "/");
			
			// Compruebo a que proceso mand la ultima vez, y cambio a alguno de los otros dos del mismo nivel
			if (cambio[nivel] == 1){
			       cambio[nivel]=0;
			       mando=nivel*3-1;
		        } else {
			       if (cambio[nivel] == 2) {
				    cambio[nivel] = 1;	
				    mando = nivel*3;
			       } else {
				    cambio[nivel]=2;	
				    mando=nivel*3-2;
			       }
			}
		       if (mando==1) mando=3;
		       printf ("VOY A MANDAR DIRECTORIO %s al %d\n", auxcad, mando);
		       // Mando directorio al proceso correspondiente
		       MPI_Isend (&auxcad, BUFSIZE, MPI_CHAR, mando, 11, MPI_COMM_WORLD, &req); 	        	
		    
		       if (nivel+1>nivelmax) {
			      nivelmax=nivel+1;
		       }
		       // El proceso 0 sigue recorriendo los directorios
		       recorrer_directorio (auxcad, nivel+1);
		}
    
	}
	closedir (puntdir);
}


void recorrer_directorio_slave (char *nombre_directorio)
{
	struct dirent *entrada;
	DIR *puntdir;
	int esdir;
	char auxcad[200], auxcad2[200];

	struct stat buffer;
		
	puntdir = opendir (nombre_directorio);  //abro directorio
	

	// Recorro el directorio guardando en la tabla, todas las entradas con sus atributos 
	while ((puntdir!=NULL) && ((entrada = readdir (puntdir)) != NULL)) { 
    
		if (strcmp(entrada->d_name,".") && strcmp(entrada->d_name,"..")){
	        	strcpy (auxcad, nombre_directorio);
			strcat (auxcad, entrada->d_name);

			lstat (auxcad, &buffer);

			strcpy (tabla[indice].direc, nombre_directorio);
			strcpy (tabla[indice].nombre, entrada->d_name);
		
	        	if (S_ISBLK(buffer.st_mode))
	            		tabla[indice].tipo='l';
			else
		    		if (S_ISCHR(buffer.st_mode)) 
		        		tabla[indice].tipo='c';
		    		else
		        		if (S_ISDIR(buffer.st_mode))
	                    			tabla[indice].tipo='d';
		        		else
		            			if (S_ISLNK(buffer.st_mode))
			        			tabla[indice].tipo='l';
		            			else
			        			tabla[indice].tipo='f';
		}
		indice++;
	}
	closedir (puntdir);
}

void comprobar_rutainicial (char *nombre_directorio)
{
        //int i, esdir, encontrado;
	//char nombre[50];
	//char direc[150];
	//char aux[150];
	MPI_Request req;
  
	//strcpy (direc,"");
	//strcpy (nombre,"");
  
	// Mando el directorio de nivel 1 que hay que guardar en cach al proceso 1
	MPI_Isend (nombre_directorio, BUFSIZE, MPI_CHAR, 1, 11, MPI_COMM_WORLD, &req);

	// comienzo a recorrer el arbol de directorios para ir repartiendo el trabajo a los procesos
	recorrer_directorio (dir_cache, 1);
  
		
}

void imprimir_tabla (int ind)
{
       int i;
	printf ("ENTRA EN IMPRIMIR TABLA");
       for (i=1; i<ind; i++) {
            printf ("%d:%s%s :%c\n", rank, tabla[i].direc, tabla[i].nombre, tabla[i].tipo);
       }
}

// Funcin que devuelve el nmero de barras ("/"), que contiene una cadena
int num_barras (char *cad){
	int tot=0;
	int i=0;
	
	do {
		if (*(cad+i)=='/')
			tot++;
		i++;
	} while (i<strlen(cad));
	return (tot);
}


// Procedimiento que ejecutan los procesos para buscar en la tabla que tiene almacenado cada uno, y guardan los resultado en lista
// Los argumentos son: El directorio sobre el que tienen que buscar en la tabla, el argumento name, si existe, y el argumento type, si existe
void Buscar (char *d, char *n, char t){
	int i;

	// Si no existe el argumento type ni el argumento name
	if (!strcmp(n,"") && t==' ') {
		for (i=1; i<indice; i++) {
		        // Guardo en la lista, todas las entradas que estn dentro del directorio especificado 
			if (strstr (tabla[i].direc, d)!=NULL)
					sprintf (lista+strlen(lista),"%s%s\n", tabla[i].direc, tabla[i].nombre);
		}
	} else {
	        // Si no existe el argumento type, pero si el name 
		if (t==' ') {
			for (i=1; i<indice; i++) {
				if ((strstr(tabla[i].direc,d)!=NULL) && !(strcmp(tabla[i].nombre, n))) 
						sprintf (lista+strlen(lista),"%s%s\n", tabla[i].direc, tabla[i].nombre);
			}	
		} else {
		        // Si no existe el argumento name, pero si el type 
			if (!strcmp(n,"")) {
				for (i=1; i<indice; i++) {
					if ((strstr(tabla[i].direc, d)!=NULL) && (tabla[i].tipo==t)) 
						sprintf (lista+strlen(lista),"%s%s\n", tabla[i].direc, tabla[i].nombre);
				}
			} else {
			        // Si existen el argumento type y el name
				for (i=1; i<indice; i++) {
					if ((strstr(tabla[i].direc, d)!=NULL) && (tabla[i].tipo==t) && !(strcmp(tabla[i].nombre,n))) 
						sprintf (lista+strlen(lista),"%s%s\n", tabla[i].direc, tabla[i].nombre);
				}
			}
		}
	}
						
				
}
					
						

int main (int argc, char *argv[])
{
	int		i;
	MPI_Status	status;
	int salir;
	MPI_Request req;
	FILE *desc, *desc2;
	char peticion[100];
	int tamanopeticion=100;
	int nodo_ini, nodo_fin;
	char directorio[BUFSIZE], nom[BUFSIZE];
	char tipo;
	int aux;
	indice=1;
	nivelmax=1;
	

	// Initialize MPI.
	MPI_Init(&argc, &argv);

	// size tiene el nmero de nodos
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	// rank tiene el nmero del nodo que tiene cada uno
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);

       
	strcpy (lista, "");

	// El proceso 0 es el master
	if (0 == rank) {
	 
	        // Recorro la estructura de directorios para guardarla en las tablas de los procesos 
		comprobar_rutainicial (dir_cache);
		
		// Mando a los procesos un buffer vaco con tag=1 , para indicarles que no hay ms directorios
		for (i=1; i<=size-1; i++) {
		    strcpy (buf, "");
		    MPI_Isend (buf, BUFSIZE, MPI_CHAR, i, 1, MPI_COMM_WORLD, &req);
		}

		// Creo las tuberias, la primera para escuchar peticiones, y la segunda para escribir los resultados
		umask (0);
		if (aux==mkfifo ("/tmp/tuberia", 0644)) 
		    printf ("ERROR EN MKFIFO %d\n", aux);
		if (aux==mkfifo ("/tmp/tuberiaret", 0644))
		    printf ("ERROR EN 2 MKFIFO %d\n", aux);

		printf (" La CACHE est llena ... ");
		desc= fopen ("/tmp/tuberia", "r");
		while (1) {

			printf ("CACHE llena, espero peticiones ... \n");
		       
		  	// Espero hasta recibir alguna peticin
			while (fgets (peticion, tamanopeticion, desc)==NULL){
		  	}	
		  
		 	extraer_argumentos (peticion);
		  	
			// Compruebo cuales son los nodos en los que tengo que buscar dependiendo del nivel que
			// tengan cada uno.
			nodo_ini= (num_barras(camino)-num_barras(dir_cache)+1);
		  	if (predicados.maxdepth.existe) 
			  	nodo_fin= (predicados.maxdepth.valor)*proc_nivel+(nodo_ini-1)*3;
			else 
				nodo_fin= nivelmax*proc_nivel;
			if (nodo_fin==3) 
				nodo_fin=1;
			if (nodo_fin>3)
				nodo_fin=nodo_fin-3;
			if (predicados.mindepth.existe)
				nodo_ini= nodo_ini+predicados.mindepth.valor-1;
			nodo_ini= nodo_ini *proc_nivel-2;
		  	if (nodo_ini==4) nodo_ini=2;
			if (nodo_ini>4) nodo_ini=nodo_ini-3;  //Causa: olvido del nivel 1
			
			printf ("NODO INI: %d \n", nodo_ini);
		  	printf ("NODO FIN: %d \n", nodo_fin);
		  	
			// Mando una peticin a los procesos seleccionados para que busquen en sus tablas
			for (i=nodo_ini; i<=nodo_fin; i++){
			  	strcpy (buf, camino);
			  	MPI_Isend (buf, BUFSIZE, MPI_CHAR, i, 3, MPI_COMM_WORLD, &req);
			  	strcpy (buf, predicados.name.valor);
			  	MPI_Isend (buf, BUFSIZE, MPI_CHAR, i, 4, MPI_COMM_WORLD, &req);
			  	MPI_Isend (&predicados.typo.valor, 1, MPI_CHAR, i, 5, MPI_COMM_WORLD, &req);
			}
		
			// Abro la tubera para devolver los resultados
			desc2= fopen ("/tmp/tuberiaret", "w+");
			if (desc2==NULL)
			        printf ("ERROR AL ABRIR LA TUBERIA RETORNO \n");

			// Recibo los resultados de los procesos y los meto en la tubera
		  	for (i=nodo_ini; i<=nodo_fin; i++){
			        strcpy (lista, "");
			  	MPI_Recv (lista, NUMCARAC, MPI_CHAR, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &status);
				fprintf (desc2, "%s", lista);
			}
			
			fprintf (desc2, "END\n");
			fclose (desc2);
			
		}
		fclose (desc);
	}else {
	        salir=0;
		
		// Recibo directorios, los recorro y guardo en la tabla hasta que recibo un tag=1
	        while (!salir) {
		      MPI_Recv(buf, BUFSIZE, MPI_CHAR, 0, MPI_ANY_TAG, MPI_COMM_WORLD, &status);
		      
		      if (status.MPI_TAG==1) 
			     salir=1;
		      else
			recorrer_directorio_slave (buf);
		}

		// Espero peticiones para buscar en la tabla, busco y devuelvo resultados al proceso 0
		while (1) {
			MPI_Recv (directorio, BUFSIZE, MPI_CHAR, 0, MPI_ANY_TAG, MPI_COMM_WORLD, &status);
			MPI_Recv (nom, BUFSIZE, MPI_CHAR, 0, MPI_ANY_TAG, MPI_COMM_WORLD, &status);
			MPI_Recv (&tipo, 1, MPI_CHAR, 0, MPI_ANY_TAG, MPI_COMM_WORLD, &status);
			strcpy (lista, "");
			Buscar (directorio, nom, tipo);
			MPI_Isend (lista, strlen(lista)+1, MPI_CHAR, 0, rank, MPI_COMM_WORLD, &req);
		}
	
	}
}















